// RayMap.h: interface for the CRayMap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RAYMAP_H__7BEC7507_E0EE_4B41_8DA9_5C60081BF8F8__INCLUDED_)
#define AFX_RAYMAP_H__7BEC7507_E0EE_4B41_8DA9_5C60081BF8F8__INCLUDED_
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000




class CRayMap  
{
private:
	//funkcje te wykorzystywane sa przez ray_casting	
	float oblicz_dla_0(long _x,long _y,int);	
	float oblicz_dla_90(long _x,long _y,int);
	float oblicz_dla_180(long _x,long _y,int);
	float oblicz_dla_270(long _x,long _y,int);

float x_step[1920];				//tablice ze wspolczynnikami nachylen dla odp katow
float y_step[1920];
float tan_table[1920];			//tablice trygonometryczny
float fabs_inv_cos_table[1920];
float inv_sin_table[1920];	
float inv_cos_table[1920];	
float inv_tan_table[1920];	
float correction_table[320];	//tablica zewierajaca wspczynniki korekcji grafiki 3d
int WORLD_ROWS;					//rozmiary swiata
int WORLD_COLUMNS;
int CELL_X_SIZE;				//rozmiary komorek
int CELL_Y_SIZE;

float rad_to_degree;			//przeskalowanie abym mogl podawac kat w stopniach
int resolution_x;				//rozdzielczosc, chyba nie powinna tutaj byc, ale nie jestem pewien
								//pewien gdzie to umiescic
int rozmiar_tablicy;			//a w zasadzie tablic trygonometrycznych, okresla dokad 
								//wykorzystuje tablice trygonometryczne
float delta_kata;				//kwant kata co ktory bedzie obliczana wartosc w tablicach

int ANGLE_30;					//najwazniejsze katy
int ANGLE_90;
int ANGLE_180;					//np kat 180 odpowiada polowie dlugosci tablicy tj. 1920/2
int ANGLE_270;
int ANGLE_360;

int world_x_size;
int world_y_size;

public:
	void ray_casting(long x, long y, int _view_angle,long scale);
float dist_array[320];  // tablica wyznaczonych odleglosci
byte bound_array[320];	// tablica przeciec - ktory pasek tekstury wybrac
int marked_texture[320];// tablica przechowuje informacje z ktora tekstura bylo przeciecie
int world[16][16];		//swiat gracza
	
	CRayMap();
	virtual ~CRayMap();
	



};

#endif // !defined(AFX_RAYMAP_H__7BEC7507_E0EE_4B41_8DA9_5C60081BF8F8__INCLUDED_)
